'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleErrors = handleErrors;
exports.fetchData = fetchData;

var _querystring = require('querystring');

var _querystring2 = babelHelpers.interopRequireDefault(_querystring);

/**
 * 捕获错误
 */
function handleErrors(response) {
  if (!response.ok) {
    throw Error(response.statusText);
  }
  return response;
}

function customHeaders(options) {
  options = options || {};
  options.headers = options.headers || {};
  options.headers['X-Requested-With'] = 'XMLHttpRequest';
  return options;
}

/**
 * 获取数据
 */
function fetchData(url, callback, params, cfgs) {
  var configs = babelHelpers.extends({
    method: 'get',
    credentials: 'include',
    mode: 'cors',
    cache: 'reload'
  }, cfgs);

  configs.method = configs.method.toLowerCase();
  if (params) {
    if (configs.method === 'get') {
      url += '?' + _querystring2.default.encode(params);
    } else if (configs.method === 'post' || configs.method === 'put' || configs.method === 'delete') {
      configs.headers = {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      };
      configs.body = JSON.stringify(params);
    }
  }

  return fetch(url, customHeaders(configs)).then(handleErrors).then(function (response) {
    return response.json();
  }).then(callback);
}