'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _classnames = require('classnames');

var _classnames2 = babelHelpers.interopRequireDefault(_classnames);

var _merge = require('lodash/merge');

var _merge2 = babelHelpers.interopRequireDefault(_merge);

var _ecConfig = require('../../common/ecConfig');

var _EChartsT = require('./ECharts.t.html');

var _EChartsT2 = babelHelpers.interopRequireDefault(_EChartsT);

var EChartsEnhance = function EChartsEnhance(ComposedComponent) {
  var _class, _temp;

  return _temp = _class = function (_Component) {
    babelHelpers.inherits(EcComponent, _Component);

    function EcComponent(props) {
      babelHelpers.classCallCheck(this, EcComponent);
      return babelHelpers.possibleConstructorReturn(this, _Component.call(this, props));
    }

    EcComponent.prototype.createOption = function createOption() {
      var _props = this.props,
          option = _props.option,
          title = _props.title,
          subTitle = _props.subTitle;

      return (0, _merge2.default)((0, _ecConfig.initOption)(this.component.props.type, title, subTitle), option);
    };

    EcComponent.prototype.createChart = function createChart() {
      this.chartOption = this.createOption();
      this.chart = (0, _ecConfig.createChart)(this.component.refs.chart.wrap, this.props.data, this.chartOption);
    };

    EcComponent.prototype.componentDidMount = function componentDidMount() {
      this.createChart();
    };

    EcComponent.prototype.componentDidUpdate = function componentDidUpdate() {
      var update = this.props.update;

      if (!update) {
        return;
      }

      var _props2 = this.props,
          data = _props2.data,
          option = _props2.option,
          title = _props2.title,
          subTitle = _props2.subTitle,
          options = _props2.options;


      (0, _ecConfig.updateChart)(this.chart, data, babelHelpers.extends({}, this.chartOption, (0, _merge2.default)({
        title: {
          text: title,
          subtext: subTitle
        },
        tooltip: {
          trigger: 'axis'
        }
      }, option)), options);
    };

    EcComponent.prototype.componentWillUnmount = function componentWillUnmount() {
      this.chart && this.chart.dispose();
    };

    EcComponent.prototype.render = function render() {
      var _this2 = this;

      var _props3 = this.props,
          className = _props3.className,
          style = _props3.style,
          height = _props3.height,
          others = babelHelpers.objectWithoutProperties(_props3, ['className', 'style', 'height']);


      var classes = (0, _classnames2.default)(babelHelpers.defineProperty({
        'vic-area-chart-area': true
      }, className, className));

      var styles = {};
      if (height != null) {
        styles.height = height;
      }
      if (style) {
        babelHelpers.extends(styles, style);
      }

      return _EChartsT2.default.enhance(this.state, {
        ComposedComponent: ComposedComponent,
        ref: function ref(c) {
          return _this2.component = c;
        },
        classes: classes,
        styles: styles,
        props: others
      });
    };

    return EcComponent;
  }(_react.Component), _class.propTypes = {
    update: _react.PropTypes.bool,
    name: _react.PropTypes.string,
    option: _react.PropTypes.object,
    data: _react.PropTypes.array,
    title: _react.PropTypes.string,
    subTitle: _react.PropTypes.string
  }, _class.defaultProps = {
    update: true
  }, _temp;
};

exports.default = EChartsEnhance;