'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _dec, _class, _desc, _value, _class2, _class3, _temp;
//import { TreeSelect } from '../antd/treeSelect';


var _react = require('react');

var _react2 = babelHelpers.interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactAddonsUpdate = require('react-addons-update');

var _reactAddonsUpdate2 = babelHelpers.interopRequireDefault(_reactAddonsUpdate);

var _nornjReact = require('nornj-react');

var _moment = require('moment');

var _moment2 = babelHelpers.interopRequireDefault(_moment);

var _coreDecorators = require('core-decorators');

var _delayOperate = require('flarej/lib/utils/delayOperate');

require('flarej/lib/styles/pagination');

require('flarej/lib/components/pagination');

require('../antd/input');

require('../antd/table');

require('../antd/tooltip');

require('../antd/button');

require('../antd/checkbox');

var _dataGridM = require('./dataGrid.m.less');

var _dataGridM2 = babelHelpers.interopRequireDefault(_dataGridM);

var _dataGridT = require('./dataGrid.t.html');

var _dataGridT2 = babelHelpers.interopRequireDefault(_dataGridT);

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var DataGrid = (_dec = (0, _nornjReact.registerTmpl)('vic-DataGrid'), _dec(_class = (_class2 = (_temp = _class3 = function (_Component) {
  babelHelpers.inherits(DataGrid, _Component);

  function DataGrid(props) {
    babelHelpers.classCallCheck(this, DataGrid);

    //数据初始化
    var _this = babelHelpers.possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {
      data: null, //表格数据
      currentData: null,
      count: null, //数据总数
      pageIndex: null, //当前页码
      pageSize: null, //每页数据数
      searchText: '',
      columnFilterHideKeys: new Set()
      //value: ['all'],
    };
    _this.state.pageIndex = props.pageIndex;
    _this.state.pageSize = props.pageSize;
    if (props.localMode) {
      _this.state.count = props.data.length;
    } else {
      _this.state.count = props.count;
      _this.state.data = props.data;
    }
    return _this;
  }

  DataGrid.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var _props = this.props,
        localMode = _props.localMode,
        pageIndex = _props.pageIndex,
        pageSize = _props.pageSize,
        count = _props.count,
        data = _props.data,
        checkPropDataRef = _props.checkPropDataRef;


    if (localMode) {
      var dataL = void 0;
      if (!checkPropDataRef || data !== nextProps.data) {
        //只有props.data的引用发生改变时才更新data参数
        dataL = nextProps.data;
      }

      if (pageIndex != nextProps.pageIndex || pageSize != nextProps.pageSize || dataL) {
        this.pageRefresh(pageIndex, pageSize, dataL ? dataL : this.state.currentData, '');
      }
    } else {
      var state = {
        pageIndex: nextProps.pageIndex,
        pageSize: nextProps.pageSize,
        count: nextProps.count
        //searchText: ''
      };

      if (!checkPropDataRef || data !== nextProps.data) {
        state.data = nextProps.data;
      }
      if (this.props.loading !== nextProps.loading) {
        state.loading = nextProps.loading;
      }

      this.setState(state);
    }
  };

  DataGrid.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    var onTableScrollBottom = this.props.onTableScrollBottom;


    if (onTableScrollBottom) {
      var tableBody = (0, _reactDom.findDOMNode)(this.refs.dataTable).querySelector('div.ant-table-body');
      tableBody.addEventListener('scroll', function () {
        (0, _delayOperate.lazyDo)(function () {
          if (tableBody.scrollTop + tableBody.clientHeight - tableBody.scrollHeight >= 0) {
            !_this2.preventScrollEvt && onTableScrollBottom(); //此处如果已经处于滚动条底端，则须阻止多次触发滚动到底部事件
            _this2.preventScrollEvt = true;
          } else {
            _this2.preventScrollEvt = false;
          }
        }, _this2.props.scrollBottomDelay, 'tableScroll', _this2);
      });
    }
  };

  // componentWillMount() {
  //   this.columns = this.treeDataFilter(this.props.cols);

  //   this.treeData = [{
  //     label: '全部',
  //     value: 'all',
  //     key: 'all',
  //     children: this.props.cols.map((item) => {
  //       return {
  //         label: item.title,
  //         value: item.dataIndex,
  //         key: item.dataIndex
  //       };
  //     })
  //   }];
  // }

  // //表头筛选
  // treeDataFilter(treeData) {
  //   //console.log(treeData.length);
  //   let result = (treeData.length == this.props.cols.length) ?
  //     this.props.cols.map((item) => {
  //       return {
  //         title: item.title,
  //         dataIndex: item.dataIndex,
  //         sorter: item.sorter ? (a, b) => compareStringCH(a[item.dataIndex], b[item.dataIndex]) : null,
  //       };
  //     }) : treeData.map((item) => {
  //       return {
  //         title: item.title,
  //         dataIndex: item.dataIndex,
  //         sorter: item.sorter ? (a, b) => compareStringCH(a[item.dataIndex], b[item.dataIndex]) : null,
  //       };
  //     });

  //   return result;
  // }

  // //表头筛选-选中任意项后的操作
  // @autobind
  // treeChange(value) {
  //   let temp = value;
  //   console.log(temp);
  //   this.setState({
  //     value: value
  //   });
  // }

  /**
   * 分页刷新
   */


  DataGrid.prototype.pageRefresh = function pageRefresh(pageIndex, pageSize, filteredData, searchText) {
    var start = (pageIndex - 1) * pageSize;
    var end = pageIndex * pageSize;
    var tempData = filteredData ? filteredData : this.props.data;

    var data = tempData.filter(function (obj, i) {
      if (i >= start && i < end) {
        return true;
      }
    });

    var state = {
      data: data,
      currentData: tempData,
      count: tempData.length,
      pageIndex: pageIndex,
      pageSize: pageSize,
      loading: false
    };

    if (searchText != null) {
      state.searchText = searchText;
    }

    this.setState(state);
  };

  /**
   * 分页控件更新事件
   */


  DataGrid.prototype.pageChange = function pageChange(pageIndex, pageSize, isInit) {
    if (this.props.localMode) {
      this.pageRefresh(pageIndex, pageSize, this.state.currentData);
    }

    if (this.props.onPageChange) {
      this.props.onPageChange(pageIndex, pageSize, isInit);
    }
  };

  /**
   * 每页显示数据数切换
   */


  DataGrid.prototype.sizeChange = function sizeChange(pageSize) {
    if (this.props.localMode) {
      this.pageRefresh(1, pageSize, this.state.currentData);
    }

    if (this.props.onPageChange) {
      this.props.onPageChange(1, pageSize);
    }
  };

  /**
   * 搜索数据结果
   */


  DataGrid.prototype.getSearchResult = function getSearchResult(inputValue) {
    var tempValue = [],
        len = inputValue.length,
        inputValueL = inputValue.toLowerCase();

    if (len) {
      this.props.data.forEach(function (item) {
        if (item == null) {
          return;
        }

        for (var i in item) {
          if (item[i] != null && item[i].toString().toLowerCase().indexOf(inputValueL) >= 0) {
            tempValue.push(item);
            break;
          }
        }
      });
      if (!tempValue.length) {
        tempValue = [];
      }
    } else {
      tempValue = null; //清空搜索框时使用props.data渲染数据
    }

    return tempValue;
  };

  /**
   * 搜索数据事件
   */


  DataGrid.prototype.searchData = function searchData(e) {
    var _this3 = this;

    var onSearchData = this.props.onSearchData;

    var value = e.target.value;
    this.setState({
      searchText: value,
      loading: true
    });

    (0, _delayOperate.lazyDo)(function () {
      if (!onSearchData) {
        if (_this3.props.localMode) {
          _this3.pageRefresh(1, _this3.state.pageSize, _this3.getSearchResult(value)); //每次搜索后都刷新到第一页
        } else {
          var ret = _this3.getSearchResult(value);
          _this3.setState({
            data: ret != null ? ret : _this3.props.data,
            loading: false
          });
        }
      } else {
        onSearchData(value, function () {
          _this3.setState({
            loading: false
          });
        });
      }
    }, this.props.searchDelay, 'vic_dataGrid');
  };

  /**
   * 筛选列复选框点击事件
   */


  DataGrid.prototype.onCfChange = function onCfChange(e) {
    var columnFilterHideKeys = this.state.columnFilterHideKeys;

    columnFilterHideKeys[e.target.checked ? 'delete' : 'add'](e.target.value);
    this.setState({
      columnFilterHideKeys: columnFilterHideKeys
    });
  };

  DataGrid.prototype.render = function render() {
    var _this4 = this;

    var filterColumns = void 0;
    if (this.props.showColumnFilter && this.props.columns) {
      //筛选列
      var columns = [];
      this.props.columns.forEach(function (col1) {
        var col2s = col1.children.filter(function (col2) {
          return !_this4.state.columnFilterHideKeys.has(col2.key);
        });
        if (col2s.length) {
          columns.push(babelHelpers.extends({}, col1, { children: col2s }));
        }
      });

      filterColumns = { columns: columns };
    }

    return (0, _dataGridT2.default)(filterColumns, this.state, this.props, this, {
      tableData: this.state.data,
      pageCount: this.refs.pagination ? this.refs.pagination.state.pageCount : 0,
      styles: _dataGridM2.default,
      showHead: this.props.showPageSize || this.props.showDataFilter || this.props.showColumnFilter,
      searchDataRef: function searchDataRef(c) {
        return _this4.searchDataInput = c;
      }
    });
  };

  return DataGrid;
}(_react.Component), _class3.propTypes = {
  columns: _react.PropTypes.array,
  locale: _react.PropTypes.object,
  data: _react.PropTypes.array,
  searchDelay: _react.PropTypes.number,
  tableProps: _react.PropTypes.object,
  onPageChange: _react.PropTypes.func,
  onTableScrollBottom: _react.PropTypes.func,
  onSearchData: _react.PropTypes.func,
  showPageSize: _react.PropTypes.bool,
  showDataCount: _react.PropTypes.bool,
  showDataFilter: _react.PropTypes.bool,
  bordered: _react.PropTypes.bool
}, _class3.defaultProps = {
  localMode: true,
  locale: {
    emptyText: '没有数据'
  },
  paginationProps: {
    showRefresh: true
  },
  scrollBottomDelay: 30,
  loading: false,
  searchDelay: 300,
  columns: null,
  data: null,
  rowSelection: null,
  count: 0,
  pageIndex: 1,
  pageSize: 15,
  pageSizes: [15, 30, 50], //可选择的每页数据数
  showPageSize: true,
  showDataCount: true,
  showDataFilter: true,
  showColumnFilter: false,
  bordered: true,
  filterInputPosition: 'right',
  checkPropDataRef: true //从prop传入data时是否检测引用值不同
  // treeDefaultExpandAll: true, //默认打开子菜单
  // searchPlaceholder: '表头查询',
  // showCheckedStrategy: TreeSelect.SHOW_PARENT, //子菜单和父菜单关联
  // multiple: true, //表头筛选 是否可以多选
  // dropdownStyle: { maxHeight: 400, width: 220, overflow: 'auto', overflowX: 'hidden' },
  // treeData: [], //表头筛选
}, _temp), (_applyDecoratedDescriptor(_class2.prototype, 'pageRefresh', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class2.prototype, 'pageRefresh'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'pageChange', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class2.prototype, 'pageChange'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'sizeChange', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class2.prototype, 'sizeChange'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'searchData', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class2.prototype, 'searchData'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onCfChange', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class2.prototype, 'onCfChange'), _class2.prototype)), _class2)) || _class);
exports.default = DataGrid;