'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _class, _temp;

var _templateObject = babelHelpers.taggedTemplateLiteral(['<#block>{#tmpl}</#block>'], ['<#block>{#tmpl}</#block>']);

var _react = require('react');

var _nornj = require('nornj');

var _nornj2 = babelHelpers.interopRequireDefault(_nornj);

require('whatwg-fetch');

var _fetchConfig = require('../../common/fetchConfig');

var _querystring = require('querystring');

var _querystring2 = babelHelpers.interopRequireDefault(_querystring);

var _utils = require('../../common/utils');

var DataSource = (_temp = _class = function (_Component) {
  babelHelpers.inherits(DataSource, _Component);

  function DataSource(props) {
    babelHelpers.classCallCheck(this, DataSource);

    var _this = babelHelpers.possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {};

    _this.fetchData = {};
    _this.fetchShim = {};
    var dataUrl = props.dataUrl;

    _this.multiUrl = (0, _nornj.isObject)(dataUrl);

    //如传入多个dataUrl，则创建fetch方法集合
    if (_this.multiUrl) {
      for (var id in dataUrl) {
        var configs = dataUrl[id],
            mehtod = configs.method;

        if (!configs.method) {
          mehtod = 'post';
        }
        _this.fetchData[id] = _this.createFetchData(configs.url, mehtod, id, configs.complete).bind(_this);

        //垫片函数，可用于修正参数结构
        if (configs.shim) {
          _this.fetchShim[id] = configs.shim.bind(_this);
        }
      }
    } else {
      _this.fetchData = _this.createFetchData(dataUrl, props.method, '');
    }
    return _this;
  }

  DataSource.prototype.createFetchData = function createFetchData(url, method, id, cb) {
    var _this2 = this;

    return function (params, callback) {
      return _this2._fetchData(url, method, params, id, callback ? callback : cb);
    };
  };

  //请求数据


  DataSource.prototype._fetchData = function _fetchData(url, method, params, id, callback) {
    var _this3 = this;

    method = method.toLowerCase();
    var fetchConfig = {
      method: method,
      credentials: 'include',
      mode: 'cors'
    };

    if (method === 'get') {
      url += '?' + _querystring2.default.encode(params);
    } else if (method === 'post') {
      fetchConfig.headers = {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      };
      fetchConfig.body = JSON.stringify(params);
    }

    return fetch(url, fetchConfig).then(_fetchConfig.handleErrors).then(function (response) {
      return response.json();
    }).then(function (result) {
      if (result.success) {
        _this3.setState(babelHelpers.defineProperty({}, 'data' + id, result.data), function () {
          callback && callback.call(_this3, result);
        });
      } else {
        _this3.setState(babelHelpers.defineProperty({}, 'data' + id, null), function () {
          callback && callback.call(_this3, result);
        });
      }

      return result;
    });
  };

  DataSource.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {};

  DataSource.prototype.componentWillMount = function componentWillMount() {
    //初始化加载数据
    if (this.multiUrl) {
      var dataUrl = this.props.dataUrl;

      for (var id in dataUrl) {
        if (dataUrl[id].initLoad) {
          this.fetchData[id]({ isInit: true });
        }
      }
    } else {
      if (this.props.initLoad) {
        this.fetchData({ isInit: true });
      }
    }
  };

  DataSource.prototype.render = function render() {
    var _props = this.props,
        dataUrl = _props.dataUrl,
        tmpls = _props.tmpls,
        otherProps = babelHelpers.objectWithoutProperties(_props, ['dataUrl', 'tmpls']);


    return (0, _nornj2.default)(_templateObject)(this.state, otherProps, {
      fetchData: this.fetchData,
      fetchShim: this.fetchShim,
      tmpl: tmpls[0]
    });
  };

  return DataSource;
}(_react.Component), _class.propTypes = {
  dataUrl: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.object]),
  initLoad: _react.PropTypes.bool,
  method: _react.PropTypes.string
}, _class.defaultProps = {
  initLoad: true,
  method: 'post'
}, _temp);


(0, _nornj.registerComponent)({ 'vic-DataSource': DataSource });
exports.default = DataSource;