'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _dec, _class, _desc, _value, _class2, _class3, _temp;

var _react = require('react');

var _reactDom = require('react-dom');

var _nornj = require('nornj');

var _nornjReact = require('nornj-react');

var _moment = require('moment');

var _moment2 = babelHelpers.interopRequireDefault(_moment);

require('moment/locale/zh-cn');

var _coreDecorators = require('core-decorators');

require('../antd/radio');

var _datePickerM = require('./datePicker.m.less');

var _datePickerM2 = babelHelpers.interopRequireDefault(_datePickerM);

var _datePickerT = require('./datePicker.t.html');

var _datePickerT2 = babelHelpers.interopRequireDefault(_datePickerT);

require('react-widgets/lib/less/react-widgets.less');

var _moment3 = require('react-widgets/lib/localizers/moment');

var _moment4 = babelHelpers.interopRequireDefault(_moment3);

var _DateTimePicker = require('react-widgets/lib/DateTimePicker');

var _DateTimePicker2 = babelHelpers.interopRequireDefault(_DateTimePicker);

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

_moment2.default.locale('zh-cn');

(0, _moment4.default)(_moment2.default);

(0, _nornj.registerComponent)({
  'rw-DateTimePicker': _DateTimePicker2.default
});

var DatePicker = (_dec = (0, _nornjReact.registerTmpl)('vic-DatePicker'), _dec(_class = (_class2 = (_temp = _class3 = function (_Component) {
  babelHelpers.inherits(DatePicker, _Component);

  function DatePicker(props) {
    babelHelpers.classCallCheck(this, DatePicker);

    var _this = babelHelpers.possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {
      period: 'year',
      date: null,
      dateString: null
    };
    var _this$props = _this.props,
        date = _this$props.date,
        period = _this$props.period;

    _this.state.date = date ? date : new Date();
    _this.state.period = period;
    _this.state.dateString = _this.convertDate(_this.state.date, period);
    return _this;
  }

  DatePicker.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var state = {};
    var needUpdate = false;

    if (nextProps.date != this.props.date) {
      state.date = nextProps.date;
      needUpdate = true;
    }
    if (nextProps.period != this.props.period) {
      state.period = nextProps.period;
      needUpdate = true;
    }

    needUpdate && this.setState(state);
  };

  DatePicker.prototype.convertDate = function convertDate(date) {
    var period = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'year';

    if (!date) {
      return '';
    }

    var m = (0, _moment2.default)(date);
    switch (period) {
      case 'year':
        return m.format('YYYY-MM');
      case 'season':
        return m.year() + '.' + m.quarter();
      case 'decade':
        return m.year() + '';
    }
  };

  DatePicker.prototype.onDateChange = function onDateChange() {
    var _state = this.state,
        dateString = _state.dateString,
        date = _state.date,
        onDateChange = this.props.onDateChange;


    onDateChange && onDateChange(dateString, date);
  };

  DatePicker.prototype.periodChange = function periodChange(e) {
    var _this2 = this;

    var period = e.target.value;
    this.isSeasonShow = false;

    this.setState({
      period: period,
      dateString: this.convertDate(this.state.date, period)
    }, function () {
      _this2.onDateChange();
    });
  };

  DatePicker.prototype.onToggle = function onToggle(isShow) {
    var _this3 = this;

    var onDateToggle = this.props.onDateToggle;

    if (this.state.period !== 'season') {
      this.isSeasonShow = false;
      onDateToggle && onDateToggle(isShow);
      return;
    }

    //用jq修改原控件模拟选择季度功能
    if (isShow && !this.isSeasonShow) {
      this.isSeasonShow = true;
      var jqDom = $((0, _reactDom.findDOMNode)(this.refs.datePicker));
      setTimeout(function () {
        return _this3.fixSeasonText(jqDom);
      }, 50);

      jqDom.find('button.rw-btn-left,button.rw-btn-right').click(function () {
        setTimeout(function () {
          return _this3.fixSeasonText(jqDom);
        }, 50);
      });
    }
    onDateToggle && onDateToggle(isShow);
  };

  /**
   * 用jq将1、4、7、10月的td移动到第一个tr内，并修改各td内文字
   */


  DatePicker.prototype.fixSeasonText = function fixSeasonText(jqDom) {
    var tds = jqDom.find('table:last td'),
        tr = jqDom.find('table:last tr:eq(0)');
    //将12个月分为4组 对应四个季度
    var tdArray = [[tds[0], tds[1], tds[2]], [tds[3], tds[4], tds[5]], [tds[6], tds[7], tds[8]], [tds[9], tds[10], tds[11]]];
    //设置四个季度的初始值
    var season = [0, 0, 0, 0];

    //遍历月份数组，找到每组第一个有'rw-empty-cell'样式的td并break
    tdArray.map(function (item, i) {
      for (var j = 0; j < item.length; j++) {
        if (!$(item[j]).hasClass('rw-empty-cell')) {
          season[i] = item[j];
          break;
        }
      }
    });

    //遍历季度数组，添加到tr中，并修改文字为季度
    season.map(function (item, i) {
      if (item !== 0) {
        $(item).find('span.rw-btn').text(i + 1 + '季度');
        tr.append(item);
      } else {
        tr.append('<td></td>');
      }
    });

    //依次移除tr的前两个td和其它显示为空的td
    tr.find('td:lt(2)').appendTo(jqDom.find('table:last tr:eq(1)'));
    tr.find('td.rw-empty-cell').appendTo(jqDom.find('table:last tr:eq(1)'));

    /*tr.append(tds[0], tds[3], tds[6], tds[9]).find('td span.rw-btn').text(function(i) {
      this.innerText = (i - 1) + '季度';
    });*/
  };

  DatePicker.prototype.onChange = function onChange(date) {
    var _this4 = this;

    this.setState({
      date: date,
      dateString: this.convertDate(date, this.state.period)
    }, function () {
      _this4.onDateChange();
    });
  };

  DatePicker.prototype.getFormat = function getFormat(period) {
    switch (period) {
      case 'year':
        return 'YYYY年MMM';
      case 'season':
        return 'YYYY年Q季度';
      case 'decade':
        return 'YYYY年';
    }
  };

  DatePicker.prototype.render = function render() {
    var period = this.state.period;


    return (0, _datePickerT2.default)(this.state, this.props, this, {
      styles: _datePickerM2.default,
      periodR: period === 'season' ? 'year' : period,
      format: this.getFormat(period),
      isHide: !this.props.showRadio ? 'vic-hidden' : ''
    });
  };

  return DatePicker;
}(_react.Component), _class3.defaultProps = {
  period: 'year',
  showRadio: true,
  showYearRadio: true,
  showSeasonRadio: true,
  showDecadeRadio: true,
  title: '日期'
}, _class3.propTypes = {
  title: _react.PropTypes.string,
  onDateChange: _react.PropTypes.func,
  onDateToggle: _react.PropTypes.func,
  datePickerProps: _react.PropTypes.object,
  date: _react.PropTypes.instanceOf(Date)
}, _temp), (_applyDecoratedDescriptor(_class2.prototype, 'onDateChange', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class2.prototype, 'onDateChange'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'periodChange', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class2.prototype, 'periodChange'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onToggle', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class2.prototype, 'onToggle'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onChange', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class2.prototype, 'onChange'), _class2.prototype)), _class2)) || _class);
exports.default = DatePicker;