'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = babelHelpers.taggedTemplateLiteral(['\n      <{ComposedComponent} {ref} {...props} {update} />\n      '], ['\n      <{ComposedComponent} {ref} {...props} {update} />\n      ']);

var _react = require('react');

var _nornj = require('nornj');

var _nornj2 = babelHelpers.interopRequireDefault(_nornj);

var _merge = require('lodash/merge');

var _merge2 = babelHelpers.interopRequireDefault(_merge);

var _hcConfig = require('../../common/hcConfig');

var hc = babelHelpers.interopRequireWildcard(_hcConfig);


var highChartsEnhance = function highChartsEnhance(ComposedComponent) {
  var _class, _temp;

  return _temp = _class = function (_Component) {
    babelHelpers.inherits(HcComponent, _Component);

    function HcComponent(props) {
      babelHelpers.classCallCheck(this, HcComponent);

      var _this = babelHelpers.possibleConstructorReturn(this, _Component.call(this, props));

      _this.state = { update: _this.props.update };
      return _this;
    }

    HcComponent.prototype.createOption = function createOption() {
      var _props = this.props,
          option = _props.option,
          title = _props.title,
          subTitle = _props.subTitle;


      return (0, _merge2.default)(hc.initOption(this.component.refs.chart.wrap, this.component.props.type, title, subTitle), option);
    };

    HcComponent.prototype.createChart = function createChart() {
      var chart = hc.createChart(this.props.data, this.createOption());

      //保存图表实例到全局对象中
      var _props2 = this.props,
          globalObj = _props2.globalObj,
          name = _props2.name;

      if (globalObj) {
        globalObj[name] = chart;
      }
    };

    HcComponent.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
      this.setState({ update: nextProps.update });
    };

    HcComponent.prototype.componentDidMount = function componentDidMount() {
      this.createChart();
    };

    HcComponent.prototype.componentDidUpdate = function componentDidUpdate() {
      if (!this.state.update) {
        return;
      }

      this.createChart();
    };

    HcComponent.prototype.render = function render() {
      var _this2 = this;

      return (0, _nornj2.default)(_templateObject)(this.state, {
        ComposedComponent: ComposedComponent,
        ref: function ref(c) {
          return _this2.component = c;
        },
        props: this.props
      });
    };

    return HcComponent;
  }(_react.Component), _class.propTypes = {
    update: _react.PropTypes.bool,
    globalObj: _react.PropTypes.object,
    name: _react.PropTypes.string,
    option: _react.PropTypes.object,
    data: _react.PropTypes.object,
    title: _react.PropTypes.string,
    subTitle: _react.PropTypes.string
  }, _class.defaultProps = {
    update: false
  }, _temp;
};

exports.default = highChartsEnhance;