'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _dec, _class, _desc, _value, _class2, _class3, _temp;

var _react = require('react');

var _nornjReact = require('nornj-react');

var _reactAddonsUpdate = require('react-addons-update');

var _reactAddonsUpdate2 = babelHelpers.interopRequireDefault(_reactAddonsUpdate);

var _coreDecorators = require('core-decorators');

require('../antd/input');

require('../antd/cascader');

var _multiSelectM = require('./multiSelect.m.less');

var _multiSelectM2 = babelHelpers.interopRequireDefault(_multiSelectM);

var _multiSelectT = require('./multiSelect.t.html');

var _multiSelectT2 = babelHelpers.interopRequireDefault(_multiSelectT);

var _delayOperate = require('flarej/lib/utils/delayOperate');

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

var MultiSelect = (_dec = (0, _nornjReact.registerTmpl)('vic-MultiSelect'), _dec(_class = (_class2 = (_temp = _class3 = function (_Component) {
  babelHelpers.inherits(MultiSelect, _Component);

  function MultiSelect(props) {
    babelHelpers.classCallCheck(this, MultiSelect);

    var _this = babelHelpers.possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {
      text: '',
      options: [],
      result: []
    };


    _this.state = (0, _reactAddonsUpdate2.default)(_this.state, { result: { $set: _this.props.defaultData } });
    return _this;
  }

  MultiSelect.prototype.getResultData = function getResultData(inputValue) {
    var tempValue = [];
    var len = inputValue.length;
    if (len) {
      this.props.defaultData.map(function (item) {
        if (item.label.indexOf(inputValue) >= 0 || item.value.indexOf(inputValue) >= 0) {
          tempValue.push(item);
          return;
        }
      });
      if (!tempValue.length) {
        tempValue = [];
      }
    } else {
      tempValue = this.props.defaultData;
    }
    return tempValue;
  };

  MultiSelect.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    this.setState({
      result: (0, _reactAddonsUpdate2.default)(this.state, { result: { $set: nextProps.defaultData } }).result
    });
  };

  MultiSelect.prototype.onChange = function onChange(value, selectedOptions) {
    this.setState({
      text: selectedOptions.map(function (obj) {
        return obj.label;
      }).join(' > '),
      result: this.props.defaultData
    });
  };

  MultiSelect.prototype.onInputChange = function onInputChange(e) {
    var _this2 = this;

    var value = e.target.value;
    this.refs.cascader.setState({ popupVisible: true });
    this.setState({ text: value });

    (0, _delayOperate.lazyDo)(function () {
      _this2.setState({
        result: _this2.getResultData(value)
      });
    }, 500, 'multiSelect');
  };

  MultiSelect.prototype.render = function render() {
    return (0, _multiSelectT2.default)(this.state, this.props, this, {
      placeholder: '输入要查询的内容',
      styles: _multiSelectM2.default
    });
  };

  return MultiSelect;
}(_react.Component), _class3.defaultProps = {
  title: '品类'
}, _class3.propTypes = {
  title: _react.PropTypes.string
}, _temp), (_applyDecoratedDescriptor(_class2.prototype, 'onChange', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class2.prototype, 'onChange'), _class2.prototype), _applyDecoratedDescriptor(_class2.prototype, 'onInputChange', [_coreDecorators.autobind], Object.getOwnPropertyDescriptor(_class2.prototype, 'onInputChange'), _class2.prototype)), _class2)) || _class);
exports.default = MultiSelect;