'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _class, _temp;

var _react = require('react');

var _nornj = require('nornj');

var _RefluxComponent2 = require('../../stateManagement/reflux/RefluxComponent');

var _RefluxComponent3 = babelHelpers.interopRequireDefault(_RefluxComponent2);

var _queryForm = require('../../stateManagement/reflux/queryForm/queryForm.action');

var _queryForm2 = babelHelpers.interopRequireDefault(_queryForm);

var _queryForm3 = require('../../stateManagement/reflux/queryForm/queryForm.store');

var _queryForm4 = babelHelpers.interopRequireDefault(_queryForm3);

require('antd/lib/grid/style/index.css');

require('../antd/card');

require('../antd/form');

require('../antd/input');

require('../antd/select');

require('../antd/cascader');

require('../antd/radio');

require('../antd/button');

var _queryFormM = require('./queryForm.m.less');

var _queryFormM2 = babelHelpers.interopRequireDefault(_queryFormM);

var _queryFormT = require('./queryForm.t.html');

var _queryFormT2 = babelHelpers.interopRequireDefault(_queryFormT);

var QueryForm = (_temp = _class = function (_RefluxComponent) {
  babelHelpers.inherits(QueryForm, _RefluxComponent);

  function QueryForm(props) {
    babelHelpers.classCallCheck(this, QueryForm);

    var _this = babelHelpers.possibleConstructorReturn(this, _RefluxComponent.call(this, props));

    _this.state = {
      business: {
        data: [],
        selected: null
      },
      brand: {
        data: [],
        selected: null
      },
      time: {
        data: [],
        selected: null
      },
      vendor: {
        data: [],
        selected: null
      },
      channel: {
        data: [],
        selected: null
      },
      department: {
        data: [],
        selected: null
      },
      category: {
        data: [],
        selected: null
      },
      period: '1'
    };

    _this.cascaderRender = function (label) {
      return label.join(' > ');
    };

    var queryAction = props.queryAction;


    _this.bindThis(['businessSelect', 'brandSelect', 'timeSelect', 'vendorSelect', 'channelSelect', 'departmentChange', 'categoryChange', 'periodChange', 'queryData', 'exportData']);

    //设置数据集
    _this.action = (0, _queryForm2.default)();
    _this.listenTo(new _queryForm4.default(_this.action), _this.storeChange);

    //监听外部action
    if (queryAction) {
      queryAction.listen(function () {
        _this.queryData();
      });
    }
    return _this;
  }

  QueryForm.prototype.componentWillMount = function componentWillMount() {
    var _this2 = this;

    //初始化各条件数据
    this.action.getTime().then(function () {
      var currQuarter = _this2.state.time.selected; //时间

      _this2.action.getBusiness(currQuarter).then(function () {
        var business = _this2.state.business.selected; //事业部

        Promise.all([_this2.action.getBrand(currQuarter), _this2.action.getVendor(currQuarter), _this2.action.getChannel(currQuarter), _this2.action.getDepartment1(currQuarter, business), _this2.action.getCategory1(currQuarter)]).then(function () {
          _this2.queryData();
        });
      });
    });
  };

  //componentWillReceiveProps (nextProps) {

  //}

  QueryForm.prototype.businessSelect = function businessSelect(value, option) {
    this.setState({
      business: {
        data: this.state.business.data,
        selected: value
      }
    });

    //重新获取部门
    this.action.getDepartment1(this.state.time.selected, value);
  };

  QueryForm.prototype.brandSelect = function brandSelect(value, option) {
    this.setState({
      brand: {
        data: this.state.brand.data,
        selected: value
      }
    });
  };

  QueryForm.prototype.timeSelect = function timeSelect(value, option) {
    var _this3 = this;

    this.setState({
      time: {
        data: this.state.time.data,
        selected: value
      }
    });

    //重新获取各条件数据
    this.action.getBusiness(value).then(function () {
      _this3.action.getDepartment1(value, _this3.state.business.selected);
    });
    this.action.getBrand(value);
    this.action.getVendor(value);
    this.action.getChannel(value);
    this.action.getCategory1(value);
  };

  QueryForm.prototype.vendorSelect = function vendorSelect(value, option) {
    this.setState({
      vendor: {
        data: this.state.vendor.data,
        selected: value
      }
    });
  };

  QueryForm.prototype.channelSelect = function channelSelect(value, option) {
    this.setState({
      channel: {
        data: this.state.channel.data,
        selected: value
      }
    });
  };

  QueryForm.prototype.departmentChange = function departmentChange(value, selectedOptions) {
    if (!selectedOptions || selectedOptions.length < 1) {
      return;
    }

    var level = selectedOptions[selectedOptions.length - 1].level,
        currQuarter = this.state.time.selected,
        //当前选中时间
    business = this.state.business.selected; //事业部

    if (level == 1) {
      //点击一级部门
      this.action.getDepartment2(currQuarter, business, value[0]);
    } else if (level == 2) {
      //点击二级分类
      this.action.getDepartment3(currQuarter, business, value[0], value[1]);
    } else if (level == 3) {
      //点击三级部门
      this.setState({
        department: {
          data: this.state.department.data,
          selected: value
        }
      });
    }
  };

  QueryForm.prototype.categoryChange = function categoryChange(value, selectedOptions) {
    if (!selectedOptions || selectedOptions.length < 1) {
      return;
    }

    var level = selectedOptions[selectedOptions.length - 1].level,
        currQuarter = this.state.time.selected; //当前选中时间

    if (level == 1) {
      //点击一级分类
      this.action.getCategory2(currQuarter, value[0]);
    } else if (level == 2) {
      //点击二级分类
      this.action.getCategory3(currQuarter, value[0], value[1]);
    } else if (level == 3) {
      //点击三级分类
      this.setState({
        category: {
          data: this.state.category.data,
          selected: value
        }
      });
    }
  };

  QueryForm.prototype.periodChange = function periodChange(e) {
    this.setState({
      period: e.target.value
    });
  };

  //componentDidMount() {
  //  this.unsubscribe = this.store.listen(this.onStatusChange);
  //}

  //componentWillUnmount() {
  //  this.unsubscribe();
  //}

  //componentDidUpdate() {

  //}

  //查询参数


  QueryForm.prototype.createQueryParam = function createQueryParam() {
    var _state = this.state,
        business = _state.business,
        brand = _state.brand,
        time = _state.time,
        vendor = _state.vendor,
        channel = _state.channel,
        department = _state.department,
        category = _state.category,
        period = _state.period;


    var params = {};
    params.deptCode = business.selected != 'all' ? business.selected : null;
    params.brandId = brand.selected != 'all' ? brand.selected : null;
    params.quarter = time.selected;
    params.vendorCode = vendor.selected != 'all' ? vendor.selected : null;
    params.vendorGrade = channel.selected != 'all' ? channel.selected : null;
    var departments = department.selected;
    if (departments) {
      if (departments.length == 1) {
        params.dept1Code = departments[0] != 'all' ? departments[0] : null;
      } else if (departments.length == 2) {
        params.dept1Code = departments[0] != 'all' ? departments[0] : null;
        params.dept2Code = departments[1] != 'all_2' ? departments[1] : null;
      } else if (departments.length == 3) {
        params.dept1Code = departments[0] != 'all' ? departments[0] : null;
        params.dept2Code = departments[1] != 'all_2' ? departments[1] : null;
        params.dept3Code = departments[2] != 'all_3' ? departments[2] : null;
      }
    }
    var categorys = category.selected;
    if (categorys) {
      if (categorys.length == 1) {
        params.brandSort1Code = categorys[0] != 'all' ? categorys[0] : null;
      } else if (categorys.length == 2) {
        params.brandSort1Code = categorys[0] != 'all' ? categorys[0] : null;
        params.brandSort2Code = categorys[1] != 'all_2' ? categorys[1] : null;
      } else if (categorys.length == 3) {
        params.brandSort1Code = categorys[0] != 'all' ? categorys[0] : null;
        params.brandSort2Code = categorys[1] != 'all_2' ? categorys[1] : null;
        params.brandSort3Code = categorys[2] != 'all_3' ? categorys[2] : null;
      }
    }

    return params;
  };

  //导出数据


  QueryForm.prototype.exportData = function exportData() {
    monitorMessage(this.action.exportData(this.createQueryParam()), 1, '正在导出数据...');
  };

  //查询数据


  QueryForm.prototype.queryData = function queryData() {
    var onQuery = this.props.onQuery;

    if (onQuery) {
      onQuery(this.createQueryParam());
    }
  };

  QueryForm.prototype.render = function render() {
    return (0, _queryFormT2.default)(this.state, {
      cascaderRender: this.cascaderRender,
      businessSelect: this.businessSelect,
      brandSelect: this.brandSelect,
      timeSelect: this.timeSelect,
      vendorSelect: this.vendorSelect,
      channelSelect: this.channelSelect,
      departmentChange: this.departmentChange,
      categoryChange: this.categoryChange,
      periodChange: this.periodChange,
      queryData: this.queryData,
      exportData: this.exportData,
      styles: _queryFormM2.default
    });
  };

  return QueryForm;
}(_RefluxComponent3.default), _class.defaultProps = {
  onQuery: null,
  queryAction: null
}, _temp);


(0, _nornj.registerComponent)({ 'vic-QueryForm': QueryForm });
exports.default = QueryForm;