'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _react = require('react');

var _react2 = babelHelpers.interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = babelHelpers.interopRequireDefault(_propTypes);

var BurgerIcon = function (_Component) {
  babelHelpers.inherits(BurgerIcon, _Component);

  function BurgerIcon(props) {
    babelHelpers.classCallCheck(this, BurgerIcon);

    var _this = babelHelpers.possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {
      hover: false
    };
    return _this;
  }

  BurgerIcon.prototype.getLineStyle = function getLineStyle(index) {
    return {
      position: 'absolute',
      height: '20%',
      left: 0,
      right: 0,
      top: 20 * (index * 2) + '%',
      opacity: this.state.hover ? 0.6 : 1
    };
  };

  BurgerIcon.prototype.render = function render() {
    var _this2 = this;

    var icon = void 0;
    var buttonStyle = {
      position: 'absolute',
      left: 0,
      top: 0,
      width: '100%',
      height: '100%',
      margin: 0,
      padding: 0,
      border: 'none',
      opacity: 0,
      fontSize: 8,
      cursor: 'pointer'
    };

    if (this.props.customIcon) {
      var extraProps = {
        className: 'bm-icon',
        style: babelHelpers.extends({ width: '100%', height: '100%' }, this.props.styles.bmIcon)
      };
      icon = _react2.default.cloneElement(this.props.customIcon, extraProps);
    } else {
      icon = _react2.default.createElement(
        'span',
        null,
        [0, 1, 2].map(function (bar) {
          return _react2.default.createElement('span', {
            key: bar,
            className: 'bm-burger-bars ' + _this2.props.barClassName,
            style: babelHelpers.extends({}, _this2.getLineStyle(bar), _this2.props.styles.bmBurgerBars)
          });
        })
      );
    }

    return _react2.default.createElement(
      'div',
      {
        className: 'bm-burger-button ' + this.props.className,
        style: babelHelpers.extends({ zIndex: 1 }, this.props.styles.bmBurgerButton)
      },
      icon,
      _react2.default.createElement(
        'button',
        {
          onClick: this.props.onClick,
          onMouseOver: function onMouseOver() {
            return _this2.setState({ hover: true });
          },
          onMouseOut: function onMouseOut() {
            return _this2.setState({ hover: false });
          },
          style: buttonStyle
        },
        'Open Menu'
      )
    );
  };

  return BurgerIcon;
}(_react.Component);

exports.default = BurgerIcon;


BurgerIcon.propTypes = {
  barClassName: _propTypes2.default.string,
  customIcon: _propTypes2.default.element,
  styles: _propTypes2.default.object
};

BurgerIcon.defaultProps = {
  barClassName: '',
  className: '',
  styles: {}
};