'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _react = require('react');

var _react2 = babelHelpers.interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = babelHelpers.interopRequireDefault(_propTypes);

var CrossIcon = function (_Component) {
  babelHelpers.inherits(CrossIcon, _Component);

  function CrossIcon() {
    babelHelpers.classCallCheck(this, CrossIcon);
    return babelHelpers.possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  CrossIcon.prototype.getCrossStyle = function getCrossStyle(type) {
    return {
      position: 'absolute',
      width: 3,
      height: 14,
      transform: type === 'before' ? 'rotate(45deg)' : 'rotate(-45deg)'
    };
  };

  CrossIcon.prototype.render = function render() {
    var _this2 = this;

    var icon;
    var buttonWrapperStyle = {
      position: 'absolute',
      width: 24,
      height: 24,
      right: 8,
      top: 8
    };
    var buttonStyle = {
      position: 'absolute',
      left: 0,
      top: 0,
      width: '100%',
      height: '100%',
      margin: 0,
      padding: 0,
      border: 'none',
      textIndent: -9999,
      background: 'transparent',
      outline: 'none',
      cursor: 'pointer'
    };

    if (this.props.customIcon) {
      var extraProps = {
        className: 'bm-cross',
        style: babelHelpers.extends({ width: '100%', height: '100%' }, this.props.styles.bmCross)
      };
      icon = _react2.default.cloneElement(this.props.customIcon, extraProps);
    } else {
      icon = _react2.default.createElement(
        'span',
        { style: { position: 'absolute', top: '6px', right: '14px' } },
        ['before', 'after'].map(function (type, i) {
          return _react2.default.createElement('span', {
            key: i,
            className: 'bm-cross ' + _this2.props.crossClassName,
            style: babelHelpers.extends({}, _this2.getCrossStyle(type), _this2.props.styles.bmCross)
          });
        })
      );
    }

    return _react2.default.createElement(
      'div',
      {
        className: 'bm-cross-button ' + this.props.className,
        style: babelHelpers.extends({}, buttonWrapperStyle, this.props.styles.bmCrossButton)
      },
      icon,
      _react2.default.createElement(
        'button',
        { onClick: this.props.onClick, style: buttonStyle },
        'Close Menu'
      )
    );
  };

  return CrossIcon;
}(_react.Component);

exports.default = CrossIcon;


CrossIcon.propTypes = {
  crossClassName: _propTypes2.default.string,
  customIcon: _propTypes2.default.element,
  styles: _propTypes2.default.object
};

CrossIcon.defaultProps = {
  crossClassName: '',
  className: '',
  styles: {}
};