'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _react = require('react');

var _utils = require('../../common/utils');

var RefluxComponent = function (_Component) {
  babelHelpers.inherits(RefluxComponent, _Component);

  function RefluxComponent(props) {
    babelHelpers.classCallCheck(this, RefluxComponent);

    var _this = babelHelpers.possibleConstructorReturn(this, _Component.call(this, props));

    _this._refluxSubscriptions = [];
    _this.bindThis(['storeChange']);
    return _this;
  }

  //为方法绑定this对象


  RefluxComponent.prototype.bindThis = function bindThis(fns) {
    (0, _utils.bindThis)(this, fns);
  };

  //数据集变化时更新组件


  RefluxComponent.prototype.storeChange = function storeChange(name, data, callback) {
    var s = {};
    s[name] = data;

    this.setState(s, callback);
  };

  RefluxComponent.prototype.listenTo = function listenTo(store, handler) {
    this._refluxSubscriptions.push(store.listen(handler));
  };

  RefluxComponent.prototype.componentWillUnmount = function componentWillUnmount() {
    if (_Component.prototype.componentWillUnmount) {
      _Component.prototype.componentWillUnmount.call(this);
    }

    for (var _iterator = this._refluxSubscriptions, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref = _i.value;
      }

      var subscriptionUnsubscribe = _ref;

      subscriptionUnsubscribe();
    }
  };

  return RefluxComponent;
}(_react.Component);

exports.default = RefluxComponent;