'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _reflux = require('reflux');

var _reflux2 = babelHelpers.interopRequireDefault(_reflux);

var RefluxStore = function () {
  function RefluxStore(action, handler) {
    babelHelpers.classCallCheck(this, RefluxStore);

    this._store = _reflux2.default.createStore({});
    this.action = action;

    //注册监听action
    if (handler) {
      this.listenTo(action, this[handler].bind(this));
    } else {
      this.listenToMany(action);
    }
  }

  RefluxStore.prototype.listenTo = function listenTo(action, handler) {
    this._store.listenTo(action, handler);
  };

  RefluxStore.prototype.listenToMany = function listenToMany(actions) {
    var _this = this;

    for (var action in actions) {
      if (actions.hasOwnProperty(action)) {
        (function () {
          var actionName = '' + action;
          var handlerName = 'on' + actionName.substring(0, 1).toUpperCase() + actionName.substring(1);
          _this._store.listenTo(actions[action], function () {
            var handler = _this[handlerName].bind(_this);
            if (handler) {
              handler.apply(undefined, arguments);
            }
          });
        })();
      }
    }
  };

  RefluxStore.prototype.listen = function listen(handler) {
    return this._store.listen(handler);
  };

  RefluxStore.prototype.trigger = function trigger() {
    var _store;

    return (_store = this._store).trigger.apply(_store, arguments);
  };

  return RefluxStore;
}();

exports.default = RefluxStore;