'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _RefluxStore2 = require('../RefluxStore');

var _RefluxStore3 = babelHelpers.interopRequireDefault(_RefluxStore2);

var _fetchConfig = require('../../../common/fetchConfig');

var _notification = require('../../../components/antd/notification');

var _modal = require('../../../components/antd/modal');

//根据id获取父级数据
function getParentDataById(parentList, id, callback) {
  parentList.every(function (d) {
    if (d.value == id) {
      callback(d);
      return false;
    }
    return true;
  });
}

var Store = function (_RefluxStore) {
  babelHelpers.inherits(Store, _RefluxStore);

  function Store() {
    babelHelpers.classCallCheck(this, Store);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = babelHelpers.possibleConstructorReturn(this, _RefluxStore.call.apply(_RefluxStore, [this].concat(args)));

    _this.time = {};
    _this.business = null;
    _this.brand = null;
    _this.vendor = null;
    _this.channel = null;
    _this.department1 = null;
    _this.department2 = null;
    _this.category1 = null;
    _this.category2 = null;
    return _this;
  }

  //获取事业部


  Store.prototype.onGetBusiness = function onGetBusiness(quarter) {
    var _this2 = this;

    fetch(G_WEB_DOMAIN + '/common/initBusiUnitnessList', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      },
      body: JSON.stringify({
        quarter: quarter
      }),
      credentials: 'include',
      mode: 'cors'
    }).then(_fetchConfig.handleErrors).then(function (response) {
      return response.json();
    }).then(function (data) {
      if (data && data.length) {
        //过滤null
        data = data.filter(function (d) {
          return d != null;
        });

        _this2.business = {
          data: data,
          selected: data[0].queryCode
        };
      } else {
        _this2.business = {
          data: null,
          selected: null
        };
      }

      _this2.trigger('business', _this2.business, function () {
        return _this2.action.getBusiness.completed();
      });
    }).catch(function (ex) {
      _this2.action.getBusiness.completed();
      _notification.Notification.error({ description: '获取事业部出错，错误是:' + ex, duration: null });
    });
  };

  //获取品牌


  Store.prototype.onGetBrand = function onGetBrand(quarter) {
    var _this3 = this;

    fetch(G_WEB_DOMAIN + '/common/getBrandListByParam', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      },
      body: JSON.stringify({
        quarter: quarter
      }),
      credentials: 'include',
      mode: 'cors'
    }).then(_fetchConfig.handleErrors).then(function (response) {
      return response.json();
    }).then(function (data) {
      if (data && data.length) {
        _this3.brand = {
          data: data,
          selected: data[0].queryCode
        };
      } else {
        _this3.brand = {
          data: null,
          selected: null
        };
      }

      _this3.trigger('brand', _this3.brand, function () {
        return _this3.action.getBrand.completed();
      });
    }).catch(function (ex) {
      _this3.action.getBrand.completed();
      _notification.Notification.error({ description: '获取品牌出错，错误是:' + ex, duration: null });
    });
  };

  //获取时间


  Store.prototype.onGetTime = function onGetTime() {
    var _this4 = this;

    //let myDate = new Date(),
    //	nowYear = myDate.getFullYear(),
    //	yearData = new Array(),
    //	currMonth = myDate.getMonth()+1,
    //	currQuarter = Math.floor((currMonth % 3 == 0 ? (currMonth / 3) : (currMonth / 3 + 1)));

    //for(let i=0;i<3;i++){
    //  let dataYear = nowYear+i-1;
    //  yearData.push({
    //    id:dataYear+"-"+1,
    //    text:dataYear+"第一季度"
    //  },{
    //    id:dataYear+"-"+2,
    //    text:dataYear+"第二季度"
    //  },{
    //    id:dataYear+"-"+3,
    //    text:dataYear+"第三季度"
    //  },{
    //    id:dataYear+"-"+4,
    //    text:dataYear+"第四季度"
    //  });
    //};

    //let time = {
    //  data: yearData,
    //  selected: nowYear+"-"+currQuarter
    //};

    //this.trigger('time', time, () => this.action.getTime.completed());

    fetch(G_WEB_DOMAIN + '/common/initQuarter', {
      method: 'GET',
      credentials: 'include',
      mode: 'cors'
    }).then(_fetchConfig.handleErrors).then(function (response) {
      return response.json();
    }).then(function (data) {
      _this4.time.data = data.filter(function (d) {
        return d.split('-')[1] != '0';
      }).map(function (d) {
        var arr = d.split('-'),
            num = void 0;
        switch (arr[1]) {
          case '1':
            num = '一';
            break;
          case '2':
            num = '二';
            break;
          case '3':
            num = '三';
            break;
          case '4':
            num = '四';
            break;
        }

        return {
          id: d,
          text: arr[0] + '\u5E74\u7B2C' + num + '\u5B63\u5EA6'
        };
      });

      _this4.time.selected = _this4.time.data[0].id;
      _this4.trigger('time', _this4.time, function () {
        return _this4.action.getTime.completed();
      });
    }).catch(function (ex) {
      _this4.action.getTime.completed();
      _notification.Notification.error({ description: '获取时间出错，错误是:' + ex, duration: null });
    });
  };

  //获取供应商


  Store.prototype.onGetVendor = function onGetVendor(quarter) {
    var _this5 = this;

    fetch(G_WEB_DOMAIN + '/common/getVendorListByParam', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      },
      body: JSON.stringify({
        quarter: quarter
      }),
      credentials: 'include',
      mode: 'cors'
    }).then(_fetchConfig.handleErrors).then(function (response) {
      return response.json();
    }).then(function (data) {
      if (data && data.length) {
        _this5.vendor = {
          data: data,
          selected: data[0].queryCode
        };
      } else {
        _this5.vendor = {
          data: null,
          selected: null
        };
      }

      _this5.trigger('vendor', _this5.vendor, function () {
        return _this5.action.getVendor.completed();
      });
    }).catch(function (ex) {
      _this5.action.getVendor.completed();
      _notification.Notification.error({ description: '获取供应商出错，错误是:' + ex, duration: null });
    });
  };

  //获取渠道


  Store.prototype.onGetChannel = function onGetChannel(quarter) {
    var _this6 = this;

    fetch(G_WEB_DOMAIN + '/common/getVendorLevelType', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      },
      body: JSON.stringify({
        quarter: quarter
      }),
      credentials: 'include',
      mode: 'cors'
    }).then(_fetchConfig.handleErrors).then(function (response) {
      return response.json();
    }).then(function (data) {
      if (data && data.length) {
        //过滤null
        data = data.filter(function (d) {
          return d && d.queryName != '';
        });

        _this6.channel = {
          data: data,
          selected: data[0].queryCode
        };
      } else {
        _this6.channel = {
          data: null,
          selected: null
        };
      }

      _this6.trigger('channel', _this6.channel, function () {
        return _this6.action.getChannel.completed();
      });
    }).catch(function (ex) {
      _this6.action.getChannel.completed();
      _notification.Notification.error({ description: '获取渠道出错，错误是:' + ex, duration: null });
    });
  };

  //获取一级部门


  Store.prototype.onGetDepartment1 = function onGetDepartment1(quarter, business) {
    var _this7 = this;

    fetch(G_WEB_DOMAIN + '/common/initDept1ListByParam', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      },
      body: JSON.stringify({
        quarter: quarter,
        deptCode: business
      }),
      credentials: 'include',
      mode: 'cors'
    }).then(_fetchConfig.handleErrors).then(function (response) {
      return response.json();
    }).then(function (data) {
      if (data && data.length) {
        _this7.department1 = {
          data: data.map(function (d, i) {
            return {
              value: d.queryCode,
              label: d.queryName,
              level: 1,
              children: i > 0 ? [{
                value: 0,
                label: '加载中...',
                level: 2
              }] : null
            };
          }),
          selected: [data[0].queryCode]
        };

        ////获取二级部门
        //this.onGetDepartment2(quarter, business, data[0].queryCode, true);
      } else {
        //没有数据
        _this7.department1 = {
          data: null,
          selected: null
        };
      }

      _this7.trigger('department', _this7.department1, function () {
        return _this7.action.getDepartment1.completed();
      });
    }).catch(function (ex) {
      _this7.action.getDepartment1.completed();
      _notification.Notification.error({ description: '获取一级部门出错，错误是:' + ex, duration: null });
    });
  };

  //获取二级部门


  Store.prototype.onGetDepartment2 = function onGetDepartment2(quarter, business, id1, isInit) {
    var _this8 = this;

    if (id1 === 'all') {
      this.department1.selected = [id1];
      this.trigger('department', this.department1, function () {
        return _this8.action.getDepartment1.completed();
      });
      return;
    }

    fetch(G_WEB_DOMAIN + '/common/initDept2ListByParam', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      },
      body: JSON.stringify({
        quarter: quarter,
        deptCode: business,
        dept1Code: id1
      }),
      credentials: 'include',
      mode: 'cors'
    }).then(_fetchConfig.handleErrors).then(function (response) {
      return response.json();
    }).then(function (data) {
      if (data && data.length) {
        getParentDataById(_this8.department1.data, id1, function (parentData) {
          parentData.children = _this8.department2 = data.map(function (d, i) {
            return {
              value: i > 0 ? d.queryCode : d.queryCode + '_2',
              label: d.queryName,
              level: 2,
              children: i > 0 ? [{
                value: 0,
                label: '加载中...',
                level: 3
              }] : null
            };
          });
        });

        //if(isInit) {  //初始化时获取三级部门
        //  this.onGetDepartment3(quarter, business, id1, data[0].queryCode, true);
        //}
        //else {  //点击一级部门
        //}
      } else {
        //没有数据
        getParentDataById(_this8.department1.data, id1, function (parentData) {
          parentData.children = [{
            value: 'none',
            label: '没有数据',
            level: 2
          }];
        });
      }

      _this8.department1.selected = [id1];
      _this8.trigger('department', _this8.department1, function () {
        return _this8.action.getDepartment1.completed();
      });
    }).catch(function (ex) {
      _this8.action.getDepartment1.completed();
      _notification.Notification.error({ description: '获取二级部门出错，错误是:' + ex, duration: null });
    });
  };

  //获取三级部门


  Store.prototype.onGetDepartment3 = function onGetDepartment3(quarter, business, id1, id2, isInit) {
    var _this9 = this;

    if (id2 === 'all_2') {
      this.department1.selected = [id1, id2];
      this.trigger('department', this.department1, function () {
        return _this9.action.getDepartment1.completed();
      });
      return;
    }

    fetch(G_WEB_DOMAIN + '/common/initDept3ListByParam', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      },
      body: JSON.stringify({
        quarter: quarter,
        deptCode: business,
        dept1Code: id1,
        dept2Code: id2
      }),
      credentials: 'include',
      mode: 'cors'
    }).then(_fetchConfig.handleErrors).then(function (response) {
      return response.json();
    }).then(function (data) {
      if (data && data.length) {
        getParentDataById(_this9.department2, id2, function (parentData) {
          parentData.children = data.map(function (d, i) {
            return {
              value: i > 0 ? d.queryCode : d.queryCode + '_3',
              label: d.queryName,
              level: 3
            };
          });
        });

        //if(isInit) {  //初始化时设置初始选中项
        //  this.department1.selected = [id1, id2, data[0].queryCode];
        //}
        //else {  //点击二级部门
        //}
      } else {
        //没有数据
        getParentDataById(_this9.department2, id2, function (parentData) {
          parentData.children = [{
            value: 'none',
            label: '没有数据',
            level: 3
          }];
        });
      }

      _this9.department1.selected = [id1, id2];
      _this9.trigger('department', _this9.department1, function () {
        return _this9.action.getDepartment1.completed();
      });
    }).catch(function (ex) {
      _this9.action.getDepartment1.completed();
      _notification.Notification.error({ description: '获取三级部门出错，错误是:' + ex, duration: null });
    });
  };

  //获取一级品类


  Store.prototype.onGetCategory1 = function onGetCategory1(quarter) {
    var _this10 = this;

    fetch(G_WEB_DOMAIN + '/common/initBrandSort1ListByParam', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      },
      body: JSON.stringify({
        quarter: quarter
      }),
      credentials: 'include',
      mode: 'cors'
    }).then(_fetchConfig.handleErrors).then(function (response) {
      return response.json();
    }).then(function (data) {
      if (data && data.length) {
        //过滤null
        data = data.filter(function (d) {
          return d && d.queryName != '';
        });

        _this10.category1 = {
          data: data.map(function (d, i) {
            return {
              value: d.queryCode,
              label: d.queryName,
              level: 1,
              children: i > 0 ? [{
                value: 0,
                label: '加载中...',
                level: 2
              }] : null
            };
          }),
          selected: ['all']
        };

        ////获取二级分类
        //this.onGetCategory2(quarter, data[0].queryCode, true);
      } else {
        //没有数据
        _this10.category1 = {
          data: null,
          selected: null
        };
      }

      _this10.trigger('category', _this10.category1, function () {
        return _this10.action.getCategory1.completed();
      });
    }).catch(function (ex) {
      _this10.action.getCategory1.completed();
      _notification.Notification.error({ description: '获取一级品类出错，错误是:' + ex, duration: null });
    });
  };

  //获取二级品类


  Store.prototype.onGetCategory2 = function onGetCategory2(quarter, id1, isInit) {
    var _this11 = this;

    if (id1 === 'all') {
      this.category1.selected = [id1];
      this.trigger('category', this.category1, function () {
        return _this11.action.getCategory1.completed();
      });
      return;
    }

    fetch(G_WEB_DOMAIN + '/common/initBrandSort2ListByParam', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      },
      body: JSON.stringify({
        quarter: quarter,
        brandSort1Code: id1
      }),
      credentials: 'include',
      mode: 'cors'
    }).then(_fetchConfig.handleErrors).then(function (response) {
      return response.json();
    }).then(function (data) {
      if (data && data.length) {
        //过滤null
        data = data.filter(function (d) {
          return d && d.queryName != '';
        });

        getParentDataById(_this11.category1.data, id1, function (parentData) {
          parentData.children = _this11.category2 = data.map(function (d, i) {
            return {
              value: i > 0 ? d.queryCode : d.queryCode + '_2',
              label: d.queryName,
              level: 2,
              children: i > 0 ? [{
                value: 0,
                label: '加载中...',
                level: 3
              }] : null
            };
          });
        });

        //if(isInit) {  //初始化时获取三级品类
        //  this.onGetCategory3(quarter, id1, data[0].queryCode, true);
        //}
        //else {  //点击一级品类
        //}
      } else {
        //没有数据
        getParentDataById(_this11.category1.data, id1, function (parentData) {
          parentData.children = [{
            value: 'none',
            label: '没有数据',
            level: 2
          }];
        });
      }

      _this11.category1.selected = [id1];
      _this11.trigger('category', _this11.category1, function () {
        return _this11.action.getCategory1.completed();
      });
    }).catch(function (ex) {
      _this11.action.getCategory1.completed();
      _notification.Notification.error({ description: '获取二级品类出错，错误是:' + ex, duration: null });
    });
  };

  //获取三级品类


  Store.prototype.onGetCategory3 = function onGetCategory3(quarter, id1, id2, isInit) {
    var _this12 = this;

    if (id2 === 'all_2') {
      this.category1.selected = [id1, id2];
      this.trigger('category', this.category1, function () {
        return _this12.action.getCategory1.completed();
      });
      return;
    }

    fetch(G_WEB_DOMAIN + '/common/initBrandSort3ListByParam', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      },
      body: JSON.stringify({
        quarter: quarter,
        brandSort1Code: id1,
        brandSort2Code: id2
      }),
      credentials: 'include',
      mode: 'cors'
    }).then(_fetchConfig.handleErrors).then(function (response) {
      return response.json();
    }).then(function (data) {
      if (data && data.length) {
        //过滤null
        data = data.filter(function (d) {
          return d && d.queryName != '';
        });

        getParentDataById(_this12.category2, id2, function (parentData) {
          parentData.children = data.map(function (d, i) {
            return {
              value: i > 0 ? d.queryCode : d.queryCode + '_3',
              label: d.queryName,
              level: 3
            };
          });
        });

        ////设置初始选中项
        //if(isInit) {
        //  this.category1.selected = [id1, id2, data[0].queryCode];
        //}
        //else {
        //}
      } else {
        //没有数据
        getParentDataById(_this12.category2, id2, function (parentData) {
          parentData.children = [{
            value: 'none',
            label: '没有数据',
            level: 3
          }];
        });
      }

      _this12.category1.selected = [id1, id2];
      _this12.trigger('category', _this12.category1, function () {
        return _this12.action.getCategory1.completed();
      });
    }).catch(function (ex) {
      _this12.action.getCategory1.completed();
      _notification.Notification.error({ description: '获取三级品类出错，错误是:' + ex, duration: null });
    });
  };

  //导出数据


  Store.prototype.onExportData = function onExportData(params) {
    var _this13 = this;

    fetch(G_WEB_DOMAIN + '/grdExcel/export', {
      method: 'POST',
      headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
      },
      body: JSON.stringify(params),
      credentials: 'include',
      mode: 'cors'
    }).then(_fetchConfig.handleErrors).then(function (response) {
      return response.json();
    }).then(function (data) {
      if (data.success) {
        _modal.Modal.success({
          title: '导出数据成功',
          okText: '确定',
          content: React.createElement(
            'div',
            { style: {
                wordWrap: 'break-word',
                wordBreak: 'break-all'
              } },
            '\u4E0B\u8F7D\u5730\u5740\uFF1A',
            React.createElement(
              'a',
              { href: data.data, target: '_blank' },
              data.data
            )
          )
        });
      } else if (data.success == false) {
        _modal.Modal.error({
          title: '数据错误',
          okText: '确定',
          content: data.message
        });
      } else {
        _modal.Modal.error({
          title: '导出数据失败',
          okText: '确定',
          content: '可能是网络出现了问题，请重试。'
        });
      }

      _this13.action.exportData.completed();
    }).catch(function (ex) {
      _this13.action.exportData.completed();
      _notification.Notification.error({ description: '导出数据出错，错误是:' + ex, duration: null });
    });
  };

  return Store;
}(_RefluxStore3.default);

exports.default = Store;